package presentation;
import javafx.ui.*;
import javafx.ui.canvas.*;
import javafx.ui.filter.*;

public class BasicPanel extends Page {
    attribute width: Number;
    attribute height: Number;
    attribute titleX: Number;
    attribute contentY: Number;
    attribute title: Node?;
    attribute content: Node?;
    operation doIntro();
    attribute alpha1: Number;
}

attribute BasicPanel.width = 900;
attribute BasicPanel.height = 600;

operation BasicPanel.doIntro() {
    titleX = [width..0] dur 500;
    contentY = [height..10] dur 500;
    for (unitinterval unit in dur 500) {
        alpha1 = if unit > 0.5 then 1-unit else 0.5 +unit;
    }
}

function BasicPanel.composeNode() =
Clip {
    shape: Rect {height: bind height, width: bind width}

    content:
    [ImageView {
        transform: translate(0, 17)
        image: {url: "{__DIR__}/image/dot.png"}
    },
    Circle {
        opacity: bind alpha1
        cx: 10.5
        cy: 27.5
        radius: 10
        fill: white
        fill:RadialGradient {
            cx: 10
            cy: 10
            radius: 12
            stops:
            [Stop {
                offset: 0
                color: white
            },
            Stop {
                offset: 1
                color: new Color(1, 1, 1, 0)
            }]
        }
    },
    Clip {
        shape: Rect {height: bind title.currentHeight, width: bind width}
        transform: bind translate(25+titleX, 48)
        content: bind title
        valign: BOTTOM
    },
    Clip {
        transform: translate(20, 50)
        shape: Rect {x: -50, height: bind height-20, width: bind width+50}
        content:
        Group {
            transform: bind translate(0, contentY)
            content:
            [Group {
                content:
                ImageView {
                    clip: bind select {shape: Rect {height: 5, width: w}} from w in width
                    image: {url: "{__DIR__}/Image/line.png"}
                }
            },
            Group {
                transform: translate(5, 10)
                content: bind content
            }]
        }
    }]
};
