package presentation;

import javafx.ui.*;
import javafx.ui.canvas.*;
import javafx.ui.filter.*;
import java.lang.*;

public class PageGroup extends Page {
   attribute panels: Page*;
   attribute selection: Integer;
   attribute selectedPanel: Page?;
}

attribute PageGroup.selectedPanel = bind panels[selection];

trigger on PageGroup.selectedPanel[oldValue] = newValue {
   oldValue.opacity = 0;
   newValue.opacity = 0;
   for (i in [false, true]) (dur 500 linear) {
	if (i) {
             doIntro();
	}
   }
}

operation PageGroup.doIntro() {
    selectedPanel.doIntro();
    selectedPanel.opacity = 1;
}

function PageGroup.composeNode() =
Group {
    content: bind selectedPanel
};
